void loadData() {

  // PULL DATA IN FROM SPL
  // 
  dataset = new DataTable("2011DataNoSubj.txt");

  columnCount = dataset.getColumnCount(); // 3
  rowCount = dataset.getRowCount(); // 73565
  //println(columnCount + ", " + rowCount);

  int rowCounter = 0; // this will be row idx          
  int nEntries = 10; // pull 10 titles for each month
  String[] titles = new String[nEntries * 12];

  // loop over n titles in SPL data
  // the more checkouts used the longer it will take to query last.fm
  for (int i = 0; i < 10; i++) {

    // index needs to change here every 10 values based on rowCounter value

    titles[i] = dataset.getValue(i, 0).replace(' ', '+'); //string from correct data index
    //println(titles[i]);

    // album.search
    //  
    // http://ws.audioscrobbler.com/2.0/?method=album.search&album=fame+monster&api_key=d023a190a026febbe19f38ba8ab53c58&format=json
    //String albumSearchTitle = "fame+monster";  
    method = "album.search";
    request = baseURL + "?method=" + method + "&album=" + titles[i] + "&api_key=" + apiKey + format;

    try {
      JSONObject lastfmData = new JSONObject(join(loadStrings(request), ""));
      JSONObject results = lastfmData.getJSONObject("results");

      // as long as there are more than 0 opensearch:totalResults, look at albummatches.
      //println(results.getInt("opensearch:totalResults"));
      if (results.getInt("opensearch:totalResults") > 0) {
        // STOPPED HERE

        JSONObject albummatches = results.getJSONObject("albummatches");

        JSONArray albums = albummatches.getJSONArray("album");
        //println(albums.get(0).toString());

        JSONObject albumObj = albums.getJSONObject(0); // get first result in array

        albumName = albumObj.getString("name").replace(' ', '+');
        artistName = albumObj.getString("artist").replace(' ', '+');
        imgURL = albumObj.getJSONArray("image").getJSONObject(3).getString("#text"); // 2 = large img

          println(albumName + ", " + artistName + ", url: " + imgURL);
      }
    }
    catch (JSONException e) {
      println ("There was an error parsing the JSONObject. (" + e.toString()+")");
    };


    // get the playcount
    if (albumName != null && artistName != null) {

      // album.getinfo
      //
      // http://ws.audioscrobbler.com/2.0/?method=album.getinfo&api_key=d023a190a026febbe19f38ba8ab53c58&artist=Lady+Gaga&album=The+Fame+Monster&format=json
      method = "album.getinfo";    
      request = baseURL + "?method=" + method + "&api_key=" + apiKey + "&artist=" + artistName + "&album=" + albumName + format;

      try {

        JSONObject lastfmData = new JSONObject(join(loadStrings(request), ""));  
        JSONObject results = lastfmData.getJSONObject("album");
        playCount = results.getInt("playcount");
        println(playCount);
      }
      catch (JSONException e) {
        println ("There was an error parsing the JSONObject. (" + e.toString()+")");
      };
    }
  } // end for
}

