import org.json.*;

// lastfm
String baseURL = "http://ws.audioscrobbler.com/2.0/";
String apiKey = "d023a190a026febbe19f38ba8ab53c58";
String format = "&format=json";
String method, request;

String albumName;
String artistName;
String imgURL;
int playCount = 0;
boolean noResult = false;

// data
DataTable dataset;
int columnCount, rowCount;

String[] textArray = new String[0];
String DL = ","; //the DELIMITER

void setup() {
  size(100, 100);

  // PULL DATA IN FROM SPL
  // 
  dataset = new DataTable("2011Data.txt");

  columnCount = dataset.getColumnCount(); // 3
  rowCount = dataset.getRowCount(); // 73565
  //println(columnCount + ", " + rowCount);

  int rowCounter = 0; // this will be row idx          
  int nEntries = 1000; // pull 10 titles for each month
  String[] titles = new String[nEntries];

  // loop over n titles in SPL data
  // the more checkouts used the longer it will take to query last.fm
  for (int i = 0; i < titles.length; i++) {

    // index needs to change here every 10 values based on rowCounter value

    titles[i] = dataset.getValue(i, 0).replace(' ', '+'); //string from correct data index
    //println(titles[i]);

    // album.search
    //  
    // http://ws.audioscrobbler.com/2.0/?method=album.search&album=fame+monster&api_key=d023a190a026febbe19f38ba8ab53c58&format=json
    //String albumSearchTitle = "fame+monster";  
    method = "album.search";
    request = baseURL + "?method=" + method + "&album=" + titles[i] + "&api_key=" + apiKey + format;

    try {
      JSONObject lastfmData = new JSONObject(join(loadStrings(request), ""));

      //println(lastfmData.has("results"));
      if (lastfmData.has("results")) {        
        JSONObject results = lastfmData.getJSONObject("results");  

        // as long as there are more than 0 opensearch:totalResults, look at albummatches.
        //println(results.getInt("opensearch:totalResults"));
        if (results.getInt("opensearch:totalResults") > 0) {

          JSONObject albummatches = results.getJSONObject("albummatches");
          JSONObject albumObj;

          // if there is only one album returned
          if (results.getInt("opensearch:totalResults") == 1) {
            albumObj = albummatches.getJSONObject("album");
          } 
          else {
            //JSONArray albums = albummatches.getJSONArray("album");       
            albumObj = albummatches.getJSONArray("album").getJSONObject(0); // get first object in array
            //println(albums.get(0).toString());
          }

          albumName = albumObj.getString("name").replaceAll("[\\p{Punct}&&[&]]", "%26").replaceAll("[\\p{Punct}&&[.]]", "%2e").replace(' ', '+');
          artistName = albumObj.getString("artist").replaceAll("[\\p{Punct}&&[&]]", "%26").replace(' ', '+');
          imgURL = albumObj.getJSONArray("image").getJSONObject(3).getString("#text"); // 2 = large img, 3= extra large

          //println(albumName + ", " + artistName + ", " + imgURL);
          noResult = false;
        } 
        else {
          noResult = true;
        }
      } 
      else {
        noResult = true;
      }
    }
    catch (JSONException e) {
      println ("There was an error parsing the JSONObject. (" + e.toString()+")");
    };


    // get the playcount
    if (!noResult) {
      // album.getinfo
      //
      // http://ws.audioscrobbler.com/2.0/?method=album.getinfo&api_key=d023a190a026febbe19f38ba8ab53c58&artist=Lady+Gaga&album=The+Fame+Monster&format=json
      method = "album.getinfo";    
      request = baseURL + "?method=" + method + "&api_key=" + apiKey + "&artist=" + artistName + "&album=" + albumName + format;

      try {

        JSONObject lastfmData = new JSONObject(join(loadStrings(request), ""));  
        JSONObject results = lastfmData.getJSONObject("album");
        playCount = results.getInt("playcount");
        //println(playCount);
      }
      catch (JSONException e) {
        println ("There was an error parsing the JSONObject. (" + e.toString()+")");
      };
    } 
    else {

      albumName = "Album Not Found";
      artistName = "Artist Not Found";
      imgURL = "imgURL Not Found";
      playCount = 0;
    }

    println(i+" : " + albumName.replace('+', ' ').replaceAll(",", "").replaceAll("%26", "&").replaceAll("%2e", ".") + ", " + artistName.replace('+', ' ').replaceAll(",", "").replaceAll("%26", "&").replaceAll("%2e", ".") + ", " + playCount + ", " + imgURL);

    // save data to text
    textArray = append(textArray, albumName.replace('+', ' ').replaceAll(",", "").replaceAll("%26", "&").replaceAll("%2e", ".") + DL + artistName.replace('+', ' ').replaceAll(",", "").replaceAll("%26", "&").replaceAll("%2e", ".") + DL + playCount + DL + imgURL);

    albumName = "";
    artistName = "";
    playCount = 0;
    imgURL = "";
  } // end for

  saveStrings("lastfmData.txt", textArray);
}


public static String removeChar(String s, char c) {
  StringBuffer r = new StringBuffer( s.length() );
  r.setLength( s.length() );
  int current = 0;
  for (int i = 0; i < s.length(); i ++) {
    char cur = s.charAt(i);
    if (cur != c) r.setCharAt( current++, cur );
  }
  return r.toString();
}

void draw() {
  exit();
}

